<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;backtrace-0.3.64&#x2F;src&#x2F;symbolize&#x2F;gimli&#x2F;stash.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>stash.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../../storage.js"></script><script src="../../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../../backtrace/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
</pre><pre class="rust"><code><span class="comment">// only used on Linux right now, so allow dead code elsewhere</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>), <span class="ident">allow</span>(<span class="ident">dead_code</span>))]</span>

<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::Mmap</span>;
<span class="kw">use</span> <span class="ident">alloc::vec</span>;
<span class="kw">use</span> <span class="ident">alloc::vec::Vec</span>;
<span class="kw">use</span> <span class="ident">core::cell::UnsafeCell</span>;

<span class="doccomment">/// A simple arena allocator for byte buffers.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Stash</span> {
    <span class="ident">buffers</span>: <span class="ident">UnsafeCell</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">mmap_aux</span>: <span class="ident">UnsafeCell</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Mmap</span><span class="op">&gt;</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">Stash</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Stash</span> {
        <span class="ident">Stash</span> {
            <span class="ident">buffers</span>: <span class="ident">UnsafeCell::new</span>(<span class="ident">Vec::new</span>()),
            <span class="ident">mmap_aux</span>: <span class="ident">UnsafeCell::new</span>(<span class="prelude-val">None</span>),
        }
    }

    <span class="doccomment">/// Allocates a buffer of the specified size and returns a mutable reference</span>
    <span class="doccomment">/// to it.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">allocate</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">size</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>] {
        <span class="comment">// SAFETY: this is the only function that ever constructs a mutable</span>
        <span class="comment">// reference to `self.buffers`.</span>
        <span class="kw">let</span> <span class="ident">buffers</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">*</span><span class="self">self</span>.<span class="ident">buffers</span>.<span class="ident">get</span>() };
        <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="ident">buffers</span>.<span class="ident">len</span>();
        <span class="ident">buffers</span>.<span class="ident">push</span>(<span class="macro">vec!</span>[<span class="number">0</span>; <span class="ident">size</span>]);
        <span class="comment">// SAFETY: we never remove elements from `self.buffers`, so a reference</span>
        <span class="comment">// to the data inside any buffer will live as long as `self` does.</span>
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">buffers</span>[<span class="ident">i</span>]
    }

    <span class="doccomment">/// Stores a `Mmap` for the lifetime of this `Stash`, returning a pointer</span>
    <span class="doccomment">/// which is scoped to just this lifetime.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_mmap_aux</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">map</span>: <span class="ident">Mmap</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] {
        <span class="comment">// SAFETY: this is the only location for a mutable pointer to</span>
        <span class="comment">// `mmap_aux`, and this structure isn&#39;t threadsafe to shared across</span>
        <span class="comment">// threads either. This also is careful to store at most one `mmap_aux`</span>
        <span class="comment">// since overwriting a previous one would invalidate the previous</span>
        <span class="comment">// pointer. Given that though we can safely return a pointer to our</span>
        <span class="comment">// interior-owned contents.</span>
        <span class="kw">unsafe</span> {
            <span class="kw">let</span> <span class="ident">mmap_aux</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">*</span><span class="self">self</span>.<span class="ident">mmap_aux</span>.<span class="ident">get</span>();
            <span class="macro">assert!</span>(<span class="ident">mmap_aux</span>.<span class="ident">is_none</span>());
            <span class="kw-2">*</span><span class="ident">mmap_aux</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">map</span>);
            <span class="ident">mmap_aux</span>.<span class="ident">as_ref</span>().<span class="ident">unwrap</span>()
        }
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="backtrace" data-search-index-js="../../../../search-index.js" data-search-js="../../../../search.js"></div>
    <script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script>
</body></html>